from __future__ import annotations

from collections.abc import Mapping
from typing import Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

from ..types import UNSET, Unset

T = TypeVar("T", bound="PkgRoutesCpPayrollFinchSessionRequest")


@_attrs_define
class PkgRoutesCpPayrollFinchSessionRequest:
    """
    Attributes:
        payroll_id (str | Unset):
        provider (str | Unset):
    """

    payroll_id: str | Unset = UNSET
    provider: str | Unset = UNSET
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        payroll_id = self.payroll_id

        provider = self.provider

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})
        if payroll_id is not UNSET:
            field_dict["payroll_id"] = payroll_id
        if provider is not UNSET:
            field_dict["provider"] = provider

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        d = dict(src_dict)
        payroll_id = d.pop("payroll_id", UNSET)

        provider = d.pop("provider", UNSET)

        pkg_routes_cp_payroll_finch_session_request = cls(
            payroll_id=payroll_id,
            provider=provider,
        )

        pkg_routes_cp_payroll_finch_session_request.additional_properties = d
        return pkg_routes_cp_payroll_finch_session_request

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
